/*
//	GLM.cc -- GLM$@%U%)!<%^%C%H2hA|%U%!%$%k$r07$&(J
//
//		created    in 4/21/1998
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	"defs.h"
#include	"GLM.h"

void	GLMLoad()
{
    unsigned char	Buffer[16 + 4];

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("%s: No such file");
    fread( Buffer, 1, 16, fp );
    if ( Buffer[0] != 'G' || Buffer[1] != 'R' || Buffer[2] != '6'
    		|| Buffer[3] != '5' )
	error ("%s: Is not glm format");
    Width = ( Buffer[12] << 8 ) + Buffer[13];
    Height = ( Buffer[14] << 8 ) + Buffer[15];
    AllocateScreen();
    fread( Screen, 1, Size, fp );
    if ( fp != stdin )
	fclose (fp);
	RightShift();
    MaxColorGuaranteed = 32768;
}

void	GLMSave()
{
	unsigned char header[]= "GR65\0\0\0\0\0\0\0\0\0\0\0\0";
	int filesize;
    if ( fp == NULL && (fp = fopen( File, "wb" )) == NULL )
	error ("%s: Cannot create");
	fwrite( header, 1, 16, fp );
	LeftShift();
    fwrite( Screen, 1, Size, fp );
	filesize= ftell( fp ) - 8;
	header[4]= filesize >> 24;
	header[5]= filesize >> 16 & 0xff;
	header[6]= filesize >> 8 & 0xff;
	header[7]= filesize & 0xff;
	header[12]= Width >> 8;
	header[13]= Width & 0xff;
	header[14]= Height >> 8;
	header[15]= Height & 0xff;
    fseek( fp, SEEK_SET, 0 );
	fwrite( header, 1, 16, fp );    
    if ( fp != stdout )
	fclose (fp);
}
